/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * mainFrame.java
 *
 * Created on 05.04.2010, 19:02:32
 */

package koverja_test;

import java.awt.Color;
import java.awt.Desktop;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.util.Random;
import java.util.jar.JarFile;
import java.util.zip.ZipEntry;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import sortieren.BubbleSort;
import sortieren.HeapSort;
import sortieren.MergeSort;
import sortieren.QuickSort;
import sortieren.SelectionSort;

/**
 *
 * @author user
 */
public class mainFrame extends javax.swing.JFrame{
    private int[] folge;
    private Random random = new Random();
    private JCheckBox[] checkboxes;
    private JLabel[] labels_zeit;
    /** Creates new form mainFrame */
    public mainFrame() {
        initComponents();
        createCheckBoxArray();
        setCheckBoxesColorRed();
        createLabelsZeitArray();
        extractSrcFiles();
        this.setTitle("App");
        this.addWindowListener(new WindowHandler());
    }
    class WindowHandler extends WindowAdapter {
    @Override
      public void windowClosing(WindowEvent e) {
  //      System.out.println("closing");
        deleteDirectory(new File("."+File.separator+"source"));
        dispose(); // Release the window resources
        System.exit(0); // End the application
      }
      public boolean deleteDirectory(File path) {
//        if( path.exists() ) {
//          File[] files = path.listFiles();
//          for(int i=0; i<files.length; i++) {
//             if(files[i].isDirectory()) {
//               deleteDirectory(files[i]);
//             }
//             else {
//               files[i].delete();
//             }
//          }
//        }
//        return( path.delete() );
    	  return true;
      }
  }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jTabbedPane1 = new javax.swing.JTabbedPane();
    jPanel1 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    checkbox_bubblesort = new javax.swing.JCheckBox();
    button_srcbubblesort = new javax.swing.JButton();
    label_zeitbubblesort = new javax.swing.JLabel();
    jPanel5 = new javax.swing.JPanel();
    checkbox_selectionsort = new javax.swing.JCheckBox();
    button_srcselectionsort = new javax.swing.JButton();
    label_zeitselectionsort = new javax.swing.JLabel();
    jPanel6 = new javax.swing.JPanel();
    checkbox_mergesort = new javax.swing.JCheckBox();
    button_srcmergesort = new javax.swing.JButton();
    label_zeitmergesort = new javax.swing.JLabel();
    jPanel7 = new javax.swing.JPanel();
    checkbox_quicksort = new javax.swing.JCheckBox();
    button_srcquicksort = new javax.swing.JButton();
    label_zeitquicksort = new javax.swing.JLabel();
    jPanel8 = new javax.swing.JPanel();
    checkbox_heapsort = new javax.swing.JCheckBox();
    button_srcheapsort = new javax.swing.JButton();
    label_zeitheapsort = new javax.swing.JLabel();
    jPanel3 = new javax.swing.JPanel();
    edit_anzahl = new javax.swing.JTextField();
    jLabel8 = new javax.swing.JLabel();
    button_start = new javax.swing.JButton();
    button_ansehen = new javax.swing.JButton();
    button_generieren = new javax.swing.JButton();
    jPanel9 = new javax.swing.JPanel();
    label_zeitgesamt = new javax.swing.JLabel();
    jLabel1 = new javax.swing.JLabel();
    jPanel2 = new javax.swing.JPanel();

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));

    checkbox_bubblesort.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    checkbox_bubblesort.setLabel(" Bubblesort");

    button_srcbubblesort.setLabel("src");
    button_srcbubblesort.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        button_srcbubblesortMouseClicked(evt);
      }
    });

    label_zeitbubblesort.setText("0 ms");

    javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
    jPanel4.setLayout(jPanel4Layout);
    jPanel4Layout.setHorizontalGroup(
      jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel4Layout.createSequentialGroup()
        .addGap(89, 89, 89)
        .addComponent(checkbox_bubblesort, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(button_srcbubblesort)
        .addGap(59, 59, 59)
        .addComponent(label_zeitbubblesort)
        .addContainerGap(442, Short.MAX_VALUE))
    );
    jPanel4Layout.setVerticalGroup(
      jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
        .addContainerGap(11, Short.MAX_VALUE)
        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(checkbox_bubblesort)
          .addComponent(button_srcbubblesort)
          .addComponent(label_zeitbubblesort))
        .addContainerGap())
    );

    checkbox_selectionsort.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    checkbox_selectionsort.setText("SelectionSort");
    checkbox_selectionsort.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        checkbox_selectionsortActionPerformed(evt);
      }
    });

    button_srcselectionsort.setLabel("src");
    button_srcselectionsort.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        button_srcselectionsortMouseClicked(evt);
      }
    });

    label_zeitselectionsort.setText("0 ms");

    javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
    jPanel5.setLayout(jPanel5Layout);
    jPanel5Layout.setHorizontalGroup(
      jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel5Layout.createSequentialGroup()
        .addGap(89, 89, 89)
        .addComponent(checkbox_selectionsort, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(button_srcselectionsort)
        .addGap(59, 59, 59)
        .addComponent(label_zeitselectionsort)
        .addContainerGap(442, Short.MAX_VALUE))
    );
    jPanel5Layout.setVerticalGroup(
      jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
        .addContainerGap(11, Short.MAX_VALUE)
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(checkbox_selectionsort)
          .addComponent(button_srcselectionsort)
          .addComponent(label_zeitselectionsort))
        .addContainerGap())
    );

    checkbox_mergesort.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    checkbox_mergesort.setText(" Mergesort");

    button_srcmergesort.setLabel("src");
    button_srcmergesort.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        button_srcmergesortMouseClicked(evt);
      }
    });

    label_zeitmergesort.setText("0 ms");

    javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
    jPanel6.setLayout(jPanel6Layout);
    jPanel6Layout.setHorizontalGroup(
      jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel6Layout.createSequentialGroup()
        .addGap(89, 89, 89)
        .addComponent(checkbox_mergesort, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(button_srcmergesort)
        .addGap(59, 59, 59)
        .addComponent(label_zeitmergesort)
        .addContainerGap(442, Short.MAX_VALUE))
    );
    jPanel6Layout.setVerticalGroup(
      jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
        .addContainerGap(11, Short.MAX_VALUE)
        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(checkbox_mergesort)
          .addComponent(button_srcmergesort)
          .addComponent(label_zeitmergesort))
        .addContainerGap())
    );

    checkbox_quicksort.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    checkbox_quicksort.setText(" Quicksort");

    button_srcquicksort.setLabel("src");
    button_srcquicksort.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        button_srcquicksortMouseClicked(evt);
      }
    });

    label_zeitquicksort.setText("0 ms");

    javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
    jPanel7.setLayout(jPanel7Layout);
    jPanel7Layout.setHorizontalGroup(
      jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel7Layout.createSequentialGroup()
        .addGap(89, 89, 89)
        .addComponent(checkbox_quicksort, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(button_srcquicksort)
        .addGap(59, 59, 59)
        .addComponent(label_zeitquicksort)
        .addContainerGap(442, Short.MAX_VALUE))
    );
    jPanel7Layout.setVerticalGroup(
      jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel7Layout.createSequentialGroup()
        .addContainerGap(11, Short.MAX_VALUE)
        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(checkbox_quicksort)
          .addComponent(button_srcquicksort)
          .addComponent(label_zeitquicksort))
        .addContainerGap())
    );

    checkbox_heapsort.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    checkbox_heapsort.setText(" Heapsort");

    button_srcheapsort.setLabel("src");
    button_srcheapsort.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        button_srcheapsortMouseClicked(evt);
      }
    });

    label_zeitheapsort.setText("0 ms");

    javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
    jPanel8.setLayout(jPanel8Layout);
    jPanel8Layout.setHorizontalGroup(
      jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel8Layout.createSequentialGroup()
        .addGap(89, 89, 89)
        .addComponent(checkbox_heapsort, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(button_srcheapsort)
        .addGap(59, 59, 59)
        .addComponent(label_zeitheapsort)
        .addContainerGap(442, Short.MAX_VALUE))
    );
    jPanel8Layout.setVerticalGroup(
      jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel8Layout.createSequentialGroup()
        .addContainerGap(11, Short.MAX_VALUE)
        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(checkbox_heapsort)
          .addComponent(button_srcheapsort)
          .addComponent(label_zeitheapsort))
        .addContainerGap())
    );

    edit_anzahl.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    edit_anzahl.setText("100");
    edit_anzahl.setName("edit_anzahl"); // NOI18N

    jLabel8.setText("Anzahl Elemente");

    button_start.setText("Start");
    button_start.setEnabled(false);
    button_start.setName("button_start"); // NOI18N
    button_start.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        button_startMouseClicked(evt);
      }
    });

    button_ansehen.setText("Folge ansehen");
    button_ansehen.setEnabled(false);
    button_ansehen.setName("button_ansehen"); // NOI18N
    button_ansehen.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        button_ansehenMouseClicked(evt);
      }
    });

    button_generieren.setText("generieren");
    button_generieren.setName("button_generieren"); // NOI18N
    button_generieren.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        button_generierenMouseClicked(evt);
      }
    });
    button_generieren.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        button_generierenActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
    jPanel3.setLayout(jPanel3Layout);
    jPanel3Layout.setHorizontalGroup(
      jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel3Layout.createSequentialGroup()
        .addGap(88, 88, 88)
        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
          .addComponent(button_start, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(edit_anzahl, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(jLabel8)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(button_generieren)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(button_ansehen)
        .addContainerGap(332, Short.MAX_VALUE))
    );
    jPanel3Layout.setVerticalGroup(
      jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel3Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(edit_anzahl, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel8)
          .addComponent(button_generieren)
          .addComponent(button_ansehen))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(button_start)
        .addContainerGap(35, Short.MAX_VALUE))
    );

    edit_anzahl.getAccessibleContext().setAccessibleName("edit_anzahl");
    button_start.getAccessibleContext().setAccessibleName("button_start");
    button_ansehen.getAccessibleContext().setAccessibleName("button_ansehen");
    button_generieren.getAccessibleContext().setAccessibleName("button_generieren");

    label_zeitgesamt.setText("0 ms");

    jLabel1.setText("Gesamt");

    javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
    jPanel9.setLayout(jPanel9Layout);
    jPanel9Layout.setHorizontalGroup(
      jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel9Layout.createSequentialGroup()
        .addGap(287, 287, 287)
        .addComponent(jLabel1)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(label_zeitgesamt)
        .addContainerGap(442, Short.MAX_VALUE))
    );
    jPanel9Layout.setVerticalGroup(
      jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
        .addContainerGap(11, Short.MAX_VALUE)
        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(label_zeitgesamt)
          .addComponent(jLabel1))
        .addContainerGap())
    );

    javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
    jPanel1.setLayout(jPanel1Layout);
    jPanel1Layout.setHorizontalGroup(
      jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel1Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(jPanel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        .addContainerGap())
    );
    jPanel1Layout.setVerticalGroup(
      jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel1Layout.createSequentialGroup()
        .addContainerGap()
        .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGap(18, 18, 18)
        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(128, Short.MAX_VALUE))
    );

    jTabbedPane1.addTab("Sortieren", jPanel1);

    javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
    jPanel2.setLayout(jPanel2Layout);
    jPanel2Layout.setHorizontalGroup(
      jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGap(0, 817, Short.MAX_VALUE)
    );
    jPanel2Layout.setVerticalGroup(
      jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGap(0, 556, Short.MAX_VALUE)
    );

    jTabbedPane1.addTab("???", jPanel2);

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 822, Short.MAX_VALUE)
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 584, Short.MAX_VALUE)
    );

    jTabbedPane1.getAccessibleContext().setAccessibleName("Sortieren");

    pack();
  }// </editor-fold>//GEN-END:initComponents

    private void button_generierenMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_button_generierenMouseClicked
        int i = -1;
        try{
            i = Integer.parseInt(edit_anzahl.getText());
            folge = new int[i];
            for(int j = 0; j< i; j++)
                folge[j] = random.nextInt();
            button_ansehen.setEnabled(true);
            button_start.setEnabled(true);
        }catch(NumberFormatException exception){
            edit_anzahl.setText("100");
        }
        setCheckBoxesColorRed();
        resetLabelsZeit();
    }//GEN-LAST:event_button_generierenMouseClicked

    private void button_generierenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_generierenActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_button_generierenActionPerformed

    private void button_ansehenMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_button_ansehenMouseClicked

        if(!button_ansehen.isEnabled()) return;

        FolgeFrame ff = new FolgeFrame();
        ff.zeigeFolge(folge);
        ff.setVisible(true);
        
    }//GEN-LAST:event_button_ansehenMouseClicked

    private void button_startMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_button_startMouseClicked
      
      if(!button_start.isEnabled()) return;

      long startzeit,endzeit,gesamtzeit=0;

      if(checkbox_bubblesort.isSelected()){
        checkbox_bubblesort.setForeground(Color.BLUE);
        startzeit = System.currentTimeMillis();
        BubbleSort.sort(folge.clone());
        endzeit = System.currentTimeMillis();
        checkbox_bubblesort.setForeground(Color.GREEN);
        gesamtzeit+=endzeit-startzeit;
        label_zeitbubblesort.setText(""+(endzeit-startzeit)+" ms");
      }
      if(checkbox_selectionsort.isSelected()){
        checkbox_selectionsort.setForeground(Color.BLUE);
        startzeit = System.currentTimeMillis();
        SelectionSort.sort(folge.clone());
        endzeit = System.currentTimeMillis();
        checkbox_selectionsort.setForeground(Color.GREEN);
        gesamtzeit+=endzeit-startzeit;
        label_zeitselectionsort.setText(""+(endzeit-startzeit)+" ms");
      }
      if(checkbox_mergesort.isSelected()){
        checkbox_mergesort.setForeground(Color.BLUE);
        startzeit = System.currentTimeMillis();
        MergeSort.sort(folge.clone());
        endzeit = System.currentTimeMillis();
        checkbox_mergesort.setForeground(Color.GREEN);
        gesamtzeit+=endzeit-startzeit;
        label_zeitmergesort.setText(""+(endzeit-startzeit)+" ms");
      }
      if(checkbox_quicksort.isSelected()){
        checkbox_quicksort.setForeground(Color.BLUE);
        startzeit = System.currentTimeMillis();
        QuickSort.sort(folge.clone());
        endzeit = System.currentTimeMillis();
        checkbox_quicksort.setForeground(Color.GREEN);
        gesamtzeit+=endzeit-startzeit;
        label_zeitquicksort.setText(""+(endzeit-startzeit)+" ms");
      }
      if(checkbox_heapsort.isSelected()){
        checkbox_heapsort.setForeground(Color.BLUE);
        startzeit = System.currentTimeMillis();
        HeapSort.sort(folge.clone());
        endzeit = System.currentTimeMillis();
        checkbox_heapsort.setForeground(Color.GREEN);
        gesamtzeit+=endzeit-startzeit;
        label_zeitheapsort.setText(""+(endzeit-startzeit)+" ms");
      }
      label_zeitgesamt.setText(""+gesamtzeit+" ms");

    }//GEN-LAST:event_button_startMouseClicked

    private void checkbox_selectionsortActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkbox_selectionsortActionPerformed
      // TODO add your handling code here:
    }//GEN-LAST:event_checkbox_selectionsortActionPerformed

    private void button_srcbubblesortMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_button_srcbubblesortMouseClicked
      String wd = System.getProperty("user.dir");
      try {
        File file = new File(wd+File.separator+"source"+File.separator+"BubbleSort.java");
        Desktop desktop = null;
        if (Desktop.isDesktopSupported()) {
          desktop = Desktop.getDesktop();
        }
        desktop.open(file);
      }
      catch (IOException ioe) {
        ioe.printStackTrace();
      }
    }//GEN-LAST:event_button_srcbubblesortMouseClicked

    private void button_srcselectionsortMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_button_srcselectionsortMouseClicked
      String wd = System.getProperty("user.dir");
      try {
        File file = new File(wd+File.separator+"source"+File.separator+"SelectionSort.java");
        Desktop desktop = null;
        if (Desktop.isDesktopSupported()) {
          desktop = Desktop.getDesktop();
        }
        desktop.open(file);
      }
      catch (IOException ioe) {
        ioe.printStackTrace();
      }
    }//GEN-LAST:event_button_srcselectionsortMouseClicked

    private void button_srcmergesortMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_button_srcmergesortMouseClicked
      String wd = System.getProperty("user.dir");
      try {
        File file = new File(wd+File.separator+"source"+File.separator+"MergeSort.java");
        Desktop desktop = null;
        if (Desktop.isDesktopSupported()) {
          desktop = Desktop.getDesktop();
        }
        desktop.open(file);
      }
      catch (IOException ioe) {
        ioe.printStackTrace();
      }
    }//GEN-LAST:event_button_srcmergesortMouseClicked

    private void button_srcquicksortMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_button_srcquicksortMouseClicked
      String wd = System.getProperty("user.dir");
      try {
        File file = new File(wd+File.separator+"source"+File.separator+"QuickSort.java");
        Desktop desktop = null;
        if (Desktop.isDesktopSupported()) {
          desktop = Desktop.getDesktop();
        }
        desktop.open(file);
      }
      catch (IOException ioe) {
        ioe.printStackTrace();
      }
    }//GEN-LAST:event_button_srcquicksortMouseClicked

    private void button_srcheapsortMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_button_srcheapsortMouseClicked
      String wd = System.getProperty("user.dir");
      try {
        File file = new File(wd+File.separator+"source"+File.separator+"HeapSort.java");
        Desktop desktop = null;
        if (Desktop.isDesktopSupported()) {
          desktop = Desktop.getDesktop();
        }
        desktop.open(file);
      }
      catch (IOException ioe) {
        ioe.printStackTrace();
      }
    }//GEN-LAST:event_button_srcheapsortMouseClicked

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new mainFrame().setVisible(true);
            }
        });
    }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton button_ansehen;
  private javax.swing.JButton button_generieren;
  private javax.swing.JButton button_srcbubblesort;
  private javax.swing.JButton button_srcheapsort;
  private javax.swing.JButton button_srcmergesort;
  private javax.swing.JButton button_srcquicksort;
  private javax.swing.JButton button_srcselectionsort;
  private javax.swing.JButton button_start;
  private javax.swing.JCheckBox checkbox_bubblesort;
  private javax.swing.JCheckBox checkbox_heapsort;
  private javax.swing.JCheckBox checkbox_mergesort;
  private javax.swing.JCheckBox checkbox_quicksort;
  private javax.swing.JCheckBox checkbox_selectionsort;
  private javax.swing.JTextField edit_anzahl;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel8;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JPanel jPanel6;
  private javax.swing.JPanel jPanel7;
  private javax.swing.JPanel jPanel8;
  private javax.swing.JPanel jPanel9;
  private javax.swing.JTabbedPane jTabbedPane1;
  private javax.swing.JLabel label_zeitbubblesort;
  private javax.swing.JLabel label_zeitgesamt;
  private javax.swing.JLabel label_zeitheapsort;
  private javax.swing.JLabel label_zeitmergesort;
  private javax.swing.JLabel label_zeitquicksort;
  private javax.swing.JLabel label_zeitselectionsort;
  // End of variables declaration//GEN-END:variables

  public void createCheckBoxArray(){
    checkboxes = new JCheckBox[5];
    checkboxes[0] = checkbox_bubblesort;
    checkboxes[1] = checkbox_selectionsort;
    checkboxes[2] = checkbox_mergesort;
    checkboxes[3] = checkbox_quicksort;
    checkboxes[4] = checkbox_heapsort;
  }

  public void setCheckBoxesColorRed(){
    for(JCheckBox j:checkboxes)
      j.setForeground(Color.red);
  }

  public void createLabelsZeitArray(){
    labels_zeit = new JLabel[6];
    labels_zeit[0] = label_zeitbubblesort;
    labels_zeit[1] = label_zeitselectionsort;
    labels_zeit[2] = label_zeitmergesort;
    labels_zeit[3] = label_zeitquicksort;
    labels_zeit[4] = label_zeitheapsort;
    labels_zeit[5] = label_zeitgesamt;
  }

  public void resetLabelsZeit(){
    for(JLabel label:labels_zeit)
      label.setText("0 ms");
  }

  public void extractFromJar(String name, String dest){
//    System.out.println("Trying to extract file "+name+" ...");
    try {
//      String home = getClass().getProtectionDomain().
//                    getCodeSource().getLocation().toString().
//                    substring(6);
      String home = getClass().getProtectionDomain()
                   .getCodeSource().getLocation()
                   .getPath().replaceAll("%20", " ");

      JarFile jar = new JarFile(home);
      ZipEntry entry = jar.getEntry(name);
      File efile = new File(dest, entry.getName());

      InputStream in =
         new BufferedInputStream(jar.getInputStream(entry));
      OutputStream out =
         new BufferedOutputStream(new FileOutputStream(efile));
      byte[] buffer = new byte[2048];
      for (;;)  {
        int nBytes = in.read(buffer);
        if (nBytes <= 0) break;
        out.write(buffer, 0, nBytes);
      }
      out.flush();
      out.close();
      in.close();
//      System.out.println("File "+name+" extracted successfully");
     }
     catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void extractSrcFiles(){
    
    boolean b = (new File("source")).mkdir();
//    System.out.println("Dir creation success="+b);
//    extractFromJar("BubbleSort.java","."+File.separator+"source");
//    extractFromJar("SelectionSort.java","."+File.separator+"source");
//    extractFromJar("MergeSort.java","."+File.separator+"source");
//    extractFromJar("Merge.java","."+File.separator+"source");
//    extractFromJar("QuickSort.java","."+File.separator+"source");
//    extractFromJar("HeapSort.java","."+File.separator+"source");
  }


}
